package com.zipcodewilmington.productmanager;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Inventory {
    public List<Product> productList;

    public Inventory(List<Product>  productList) {
        this.productList = productList;
    }

    public Inventory(){
        this.productList = new ArrayList<Product>();
    }

    public List<Product> getProductList(){
        return productList;
    }

    public void add(Product product){

        productList.add(product);
    }

    public void remove(Product product) {

        productList.remove(product);
    }


    public Double getTotalValue() {
        Double sum = 0.0;
        for(Product product: productList){
            sum+= product.getPrice() * product.getQuantity();
        }
        return sum;
    }


    public Boolean contains(Product product) {
    return productList.contains(product);
    }

    public int size() {
        return productList.size();
    }

    public void removeById(Integer id){
        Iterator<Product> productIterator= productList.iterator();
        while(productIterator.hasNext()){
            Product product = productIterator.next();
            if(product.getId()==(id)){
                productIterator.remove();
                break;
            }
        }
    }


}
