package com.zipcodewilmington.productmanager;

import org.junit.Assert;
import org.junit.Test;
import java.util.ArrayList;
import java.util.List;

public class InventoryTest {
    @Test
    public void constructorTest(){
        //given
        List<Product> productList = new ArrayList<Product>();

        //When
        Inventory inventory= new Inventory(productList);

        //then
        Assert.assertEquals(productList, inventory.getProductList());
    }

    @Test
    public void addTest(){
        //Given
        Inventory inventory= new Inventory();
        Product product = new Product(50.7,1,2);
        //When
        inventory.add(product);
        //Then
        Assert.assertTrue(inventory.contains(product));
    }

    @Test
    public void removeTest(){
        //Given
        Inventory inventory= new Inventory();
        Product product = new Product(50.7, 1, 2);
        inventory.add(product);
        //When
        inventory.remove(product);
        //Then
        Assert.assertFalse(inventory.contains(product));
    }

    @Test
    public void sizeTest(){
        //given
        Inventory inventory= new Inventory();
        Product product= new Product(50.7,1,2);
        inventory.add(product);
        int expected = 1;
        //when
        int actual = inventory.size();
        //then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void containsTest(){
        //given
        Inventory inventory= new Inventory();
        Product product= new Product(50.7,1,2);
        inventory.add(product);
        boolean expected = true;
        //when
        boolean actual = inventory.contains(product);
        //then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void toStringTest(){

    }

    @Test
    public void mergeInventories(){
        Inventory inventory = new Inventory();
    }

    @Test
    public void getTotalValue(){
        Inventory inventory = new Inventory();
        Double price = 10.0;
        int quantity = 5;

        Double expected = price*quantity;

        Product product = new Product(price, 1, quantity);

        inventory.add(product);


        Double actual= inventory.getTotalValue();

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void getTotalValue2(){
        Inventory inventory = new Inventory();
        Double price = 5.0;
        Double price2 = 15.0;
        int quantity = 12;
        int quantity1 = 5;

        Double expected = (price*quantity)+(price2*quantity1);

        Product product = new Product(price, 1, quantity);
        Product product1= new Product(price2, 2, quantity1);
        inventory.add(product);
        inventory.add(product1);

        Double actual= inventory.getTotalValue();

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void nullaryConstuctorTest(){
        Inventory inventory= new Inventory();

        List<Product> productList = inventory.getProductList();
        Assert.assertNotNull(productList);
        Assert.assertTrue(productList.isEmpty());
    }
    public void removeById(){
        Inventory inventory= new Inventory();
        int id =2;
        Product product = new Product(50.7,1,2);
        inventory.add(product);

        inventory.removeById(id);

        Assert.assertFalse(inventory.contains(product));
    }
}
